// *** SciGui main function
// *** by G. Casonato - Marzo 2007

function SciGui ()
  // editor per costruire GUI

  // costruzione della parte grafica della finestra principale

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // *** chiusura file aperti ***
  file('close',file());

  // crea finestra principale
  fx = 100;
  fy = 100;
  fw = 400;
  fh = 1;
  hfig = figure(1, 'position', [fx fy fw fh]);
  disp(hfig);

  // aggiunge oggetti alla menu bar

  // menu FILE
  hmenuFile = uimenu(hfig, 'label', 'File');
  hmenuFileNew = uimenu(hmenuFile, 'label', 'New...', 'callback', "cbFileNew");
  hmenuFileLoad = uimenu(hmenuFile, 'label', 'Load...', 'callback', "cbFileLoad");
  hmenuFileSave = uimenu(hmenuFile, 'label', 'Save...', 'callback', "cbFileSave");
  hmenuFileQuit = uimenu(hmenuFile, 'label', 'Quit', 'callback', "cbFileQuit");

  // menu EDIT
  hmenuEdit = uimenu(hfig, 'label', 'Edit');

  // submenu ADD
  hmenuAdd = uimenu(hmenuEdit, 'label', 'Add');
  hmenuAddButton = uimenu(hmenuAdd, 'label', 'Button...', 'callback', "cbAddButton");
  hmenuAddTextField = uimenu(hmenuAdd, 'label', 'TextField...', 'callback', "cbAddTextField");
  hmenuAddLabel = uimenu(hmenuAdd, 'label', 'Label...', 'callback', "cbAddLabel");
  hmenuAddListBox = uimenu(hmenuAdd, 'label', 'ListBox...', 'callback', "cbAddListBox");
  hmenuAddCheckBox = uimenu(hmenuAdd, 'label', 'CheckBox...', 'callback', "cbAddCheckBox");
  hmenuAddFrame = uimenu(hmenuAdd, 'label', 'Frame...', 'callback', "cbAddFrame");
  hmenuAddRadioButton = uimenu(hmenuAdd, 'label', 'RadioButton...', 'callback', "cbAddRadioButton");
  hmenuAddPopupMenu = uimenu(hmenuAdd, 'label', 'PopupMenu...', 'callback', "cbAddPopupMenu");
  hmenuAddSlider = uimenu(hmenuAdd, 'label', 'Slider...', 'callback', "cbAddSlider");

  // submenu MODIFY
  hmenuModify = uimenu(hmenuEdit, 'label', 'Modify');
  hmenuModifyFigure = uimenu(hmenuModify, 'label', 'Figure...', 'callback', "cbEditFigure");
  hmenuModifyButton = uimenu(hmenuModify, 'label', 'Button...', 'callback', "cbEditButton");
  hmenuModifyTextField = uimenu(hmenuModify, 'label', 'TextField...', 'callback', "cbEditTextField");
  hmenuModifyLabel = uimenu(hmenuModify, 'label', 'Label...', 'callback', "cbEditLabel");
  hmenuModifyListBox = uimenu(hmenuModify, 'label', 'ListBox...', 'callback', "cbEditListBox");
  hmenuModifyCheckBox = uimenu(hmenuModify, 'label', 'CheckBox...', 'callback', "cbEditCheckBox");
  hmenuModifyFrame = uimenu(hmenuModify, 'label', 'Frame...', 'callback', "cbEditFrame");
  hmenuModifyRadioButton = uimenu(hmenuModify, 'label', 'RadioButton...', 'callback', "cbEditRadioButton");
  hmenuModifyPopupMenu = uimenu(hmenuModify, 'label', 'PopupMenu...', 'callback', "cbEditPopupMenu");
  hmenuModifySlider = uimenu(hmenuModify, 'label', 'Slider...', 'callback', "cbEditSlider");

  // submenu DELETE
  hmenuDelete = uimenu(hmenuEdit, 'label', 'Delete');
  hmenuDeleteButton = uimenu(hmenuDelete, 'label', 'Button...', 'callback', "cbDeleteButton");
  hmenuDeleteTextField = uimenu(hmenuDelete, 'label', 'TextField...', 'callback', "cbDeleteTextField");
  hmenuDeleteLabel = uimenu(hmenuDelete, 'label', 'Label...', 'callback', "cbDeleteLabel");
  hmenuDeleteListBox = uimenu(hmenuDelete, 'label', 'ListBox...', 'callback', "cbDeleteListBox");
  hmenuDeleteCheckBox = uimenu(hmenuDelete, 'label', 'CheckBox...', 'callback', "cbDeleteCheckBox");
  hmenuDeleteFrame = uimenu(hmenuDelete, 'label', 'Frame...', 'callback', "cbDeleteFrame");
  hmenuDeleteRadioButton = uimenu(hmenuDelete, 'label', 'RadioButton...', 'callback', "cbDeleteRadioButton");
  hmenuDeletePopupMenu = uimenu(hmenuDelete, 'label', 'PopupMenu...', 'callback', "cbDeletePopupMenu");
  hmenuDeleteSlider = uimenu(hmenuDelete, 'label', 'Slider...', 'callback', "cbDeleteSlider");

  // menu OPTIONS
  hmenuOptions = uimenu(hfig, 'label', 'Options');
  hmenuOptionsGrid = uimenu(hmenuOptions, 'label', 'Toggle Grid', 'callback', "cbOptionsGrid");

  // menu HELP
  hmenuHelp = uimenu(hfig, 'label', '?');
  hmenuHelpAbout = uimenu(hmenuHelp, 'label', 'About', 'callback', "cbHelpAbout");

  // crea finestra di lavoro
  resetGlobals();  
  hfig_wk = editFigure ('new', hfig, 2);
  disp(hfig_wk);

endfunction



/////////////////////////////////////////////////
////////////       CALLBACKS         ////////////
/////////////////////////////////////////////////

///// FILE //////

function cbFileNew()
  disp('File New...');
  
  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // reset finestra di lavoro e lista oggetti
//  close(hfig_wk);
  resetGlobals();
  hfig_wk = editFigure ('edit', hfig, 2);
  
  disp('done.');
endfunction

function cbFileLoad()
  disp('File Load...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // carica dati da file SCIGUI
  fname = getFileName ('load');
  fd = mopen(fname, 'r');

  // reset finestra di lavoro
//  close(hfig_wk);
  resetGlobals();
//  hfig_wk = editFigure ('new', hfig, 2);
  resetFigure(hfig_wk);
  
  // legge prima riga
  str = mgetl(fd, 1);
  while meof(fd) == 0
    // processa riga letta
    if strindex(str, '// MAIN GUI') == 1 then
      // dati finestra - leggi e aggiorna posizione
      loadFigure (fd, hfig_wk);
      
    elseif strindex(str, '// BUTTON') == 1 then
      // dati pulsante - crea con stessi parametri
      hobj = loadButton (fd, hfig_wk);
      hobjs = [hobjs; hobj];

    elseif strindex(str, '// TEXTFIELD') == 1 then
      // dati textfield - crea con stessi parametri
      hobj = loadTextField (fd, hfig_wk);
      hobjs = [hobjs; hobj];

    elseif strindex(str, '// LABEL') == 1 then
      // dati label - crea con stessi parametri
      hobj = loadLabel (fd, hfig_wk);
      hobjs = [hobjs; hobj];

    elseif strindex(str, '// LISTBOX') == 1 then
      // dati listbox - crea con stessi parametri
      hobj = loadListBox (fd, hfig_wk);
      hobjs = [hobjs; hobj];

    elseif strindex(str, '// CHECKBOX') == 1 then
      // dati checkbox - crea con stessi parametri
      hobj = loadCheckBox (fd, hfig_wk);
      hobjs = [hobjs; hobj];

    elseif strindex(str, '// FRAME') == 1 then
      // dati frame - crea con stessi parametri
      hobj = loadFrame (fd, hfig_wk);
      hobjs = [hobjs; hobj];

    elseif strindex(str, '// RADIOBUTTON') == 1 then
      // dati radiobutton - crea con stessi parametri
      hobj = loadRadioButton (fd, hfig_wk);
      hobjs = [hobjs; hobj];

    elseif strindex(str, '// POPUPMENU') == 1 then
      // dati popupmenu - crea con stessi parametri
      hobj = loadPopupMenu (fd, hfig_wk);
      hobjs = [hobjs; hobj];
      
    elseif strindex(str, '// SLIDER') == 1 then
      // dati slider - crea con stessi parametri
      hobj = loadSlider (fd, hfig_wk);
      hobjs = [hobjs; hobj];

    elseif strindex(str, '// CALLBACK') == 1 then
      // dati callback - memorizza in lista dedicata
      hcb = loadCallback(fd);
      hcblist($+1) = hcb;

    elseif strindex(str, '// INIT-PRE-BEGIN') == 1 then
      // dati inizializzazioni preliminari - memorizza in lista dedicata
      hpreinit = loadPreInit(fd);

    elseif strindex(str, '// INIT-POST-BEGIN') == 1 then
      // dati inizializzazioni finali - memorizza in lista dedicata
      hpostinit = loadPostInit(fd);

    elseif strindex(str, '// AUX-FUN-BEGIN') == 1 then
      // dati funzioni ausiliarie - memorizza in lista dedicata
      hauxfun = loadAuxFun(fd);
      
    end

    // legge prossima riga
    str = mgetl(fd, 1);
  end

  mclose(fd);
  drawGrid(hfig_wk);
  disp('done..');

endfunction

function cbFileSave()
  disp('File Save...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // salva dati in file SCIGUI
//  mfun = 'myGui';
  mfun = get(hfig_wk, 'tag');;
  fname = getFileName ('save');
  fd = mopen(fname, 'w');

//  mfprintf(fd, '// %s\n', fname);
  mfprintf(fd, '// *** SCIGUI V %s AUTO-GENERATED FILE ***\n', SCIGUI_VERSION);
  mfprintf(fd, '// *** DO NOT EDIT BUT SPECIFIED ENTRY-POINTS ***\n\n\n');
  mfprintf(fd, '// MAIN FUNCTION\n');
  mfprintf(fd, 'function %s ()\n\n', mfun);

  // pre-init settings
  savePreInit (fd, hpreinit);

  // main GUI
  saveFigure (fd, hfig_wk);
  
  // oggetti grafici
  if size(hobjs, 1) > 0 then
    mfprintf(fd, '// Create objects\n');
  end
  for i = 1 : size(hobjs, 1)
    if get(hobjs(i), 'Parent') > 1 then
      objType = get(hobjs(i), 'style');
      select objType
        case 'pushbutton' then
          saveButton (fd, hobjs(i));

        case 'edit' then
          saveTextField (fd, hobjs(i));

        case 'text' then
          saveLabel (fd, hobjs(i));

        case 'listbox' then
          saveListBox (fd, hobjs(i));

        case 'checkbox' then
          saveCheckBox (fd, hobjs(i));

        case 'frame' then
          saveFrame (fd, hobjs(i));

        case 'radiobutton' then
          saveRadioButton (fd, hobjs(i));

        case 'popupmenu' then
          savePopupMenu (fd, hobjs(i));

        case 'slider' then
          saveSlider (fd, hobjs(i));
      end
    end
  end
  
  // post-init settings
  savePostInit (fd, hpostinit);
  
  mfprintf(fd, 'endfunction\n\n\n');
  
  // callbacks (solo per push button)
  for i = 1 : size(hcblist)
    saveCallback (fd, hcblist(i));
  end  

  // auxiliary functions
  saveAuxFun (fd, hauxfun);  

  mclose(fd);
  disp('Save done.');
endfunction

function cbFileQuit()
  disp('File Quit...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  disp(hobjs);
  close(hfig_wk);
  close(hfig); 
  hobjs = [];
  
  disp('SciGui closed.');
endfunction


///// EDIT-ADD //////

function cbAddButton()
  disp('Add Button...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');
  
  // crea oggetto
  id = size(hobjs, 1) + 1;
  hbut = editButton('new', hfig_wk, id);
  hobjs = [hobjs; hbut];
  
  // crea corpo CB e aggiunge alla lista
  objcb = get(hbut, 'callback');
  hcb = list();
  hcb($+1) = 'function ' + objcb;
  hcb($+1) = '  disp(''...CB <' + objcb + '> called...'');';
  hcb($+1) = 'endfunction';
  hcblist($+1) = hcb;
endfunction

function cbAddTextField()
  disp('Add TextField...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // crea oggetto
  id = size(hobjs, 1) + 1;
  hobj = editTextField('new', hfig_wk, id);
  hobjs = [hobjs; hobj];
endfunction

function cbAddLabel()
  disp('Add Label...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // crea oggetto
  id = size(hobjs, 1) + 1;
  hobj = editLabel('new', hfig_wk, id);
  hobjs = [hobjs; hobj];
endfunction

function cbAddListBox()
  disp('Add ListBox...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // crea oggetto
  id = size(hobjs, 1) + 1;
  hobj = editListBox('new', hfig_wk, id);
  hobjs = [hobjs; hobj];
endfunction

function cbAddCheckBox()
  disp('Add CheckBox...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // crea oggetto
  id = size(hobjs, 1) + 1;
  hobj = editCheckBox('new', hfig_wk, id);
  hobjs = [hobjs; hobj];
endfunction

function cbAddFrame ()
  disp('Add Frame ...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // crea oggetto
  id = size(hobjs, 1) + 1;
  hobj = editFrame('new', hfig_wk, id);
  hobjs = [hobjs; hobj];
endfunction

function cbAddRadioButton ()
  disp('Add RadioButton ...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // crea oggetto
  id = size(hobjs, 1) + 1;
  hobj = editRadioButton ('new', hfig_wk, id);
  hobjs = [hobjs; hobj];
endfunction

function cbAddPopupMenu ()
  disp('Add PopupMenu ...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // crea oggetto
  id = size(hobjs, 1) + 1;
  hobj = editPopupMenu ('new', hfig_wk, id);
  hobjs = [hobjs; hobj];
endfunction

function cbAddSlider ()
  disp('Add Slider ...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // crea oggetto
  id = size(hobjs, 1) + 1;
  hobj = editSlider ('new', hfig_wk, id);
  hobjs = [hobjs; hobj];
endfunction


///// EDIT-MODIFY //////

function cbEditFigure()
  disp('Edit Figure...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // apri finestra con valori attuali
  editFigure('edit', hfig, hfig_wk);
endfunction

function cbEditButton()
  disp('Edit Button...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // seleziona oggetto
  hobj = selectObject (hobjs, 'pushbutton');
  
  // apri finestra con valori attuali
  if hobj > 0 then
    editButton('edit', hfig_wk, hobj);
  end
endfunction

function cbEditTextField()
  disp('Edit TextField...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // seleziona oggetto
  hobj = selectObject (hobjs, 'edit');
  
  // apri finestra con valori attuali
  if hobj > 0 then
    editTextField('edit', hfig_wk, hobj);
  end
endfunction

function cbEditLabel()
  disp('Edit Label...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // seleziona oggetto
  hobj = selectObject (hobjs, 'text');
  
  // apri finestra con valori attuali
  if hobj > 0 then
    editLabel('edit', hfig_wk, hobj);
  end
endfunction

function cbEditListBox()
  disp('Edit ListBox...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // seleziona oggetto
  hobj = selectObject (hobjs, 'listbox');
  
  // apri finestra con valori attuali
  if hobj > 0 then
    editListBox('edit', hfig_wk, hobj);
  end
endfunction

function cbEditCheckBox()
  disp('Edit CheckBox...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // seleziona oggetto
  hobj = selectObject (hobjs, 'checkbox');
  
  // apri finestra con valori attuali
  if hobj > 0 then
    editCheckBox('edit', hfig_wk, hobj);
  end
endfunction

function cbEditFrame ()
  disp('Edit Frame ...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // seleziona oggetto
  hobj = selectObject (hobjs, 'frame');
  
  // apri finestra con valori attuali
  if hobj > 0 then
    editFrame ('edit', hfig_wk, hobj);
  end
endfunction

function cbEditRadioButton ()
  disp('Edit RadioButton ...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // seleziona oggetto
  hobj = selectObject (hobjs, 'radiobutton');
  
  // apri finestra con valori attuali
  if hobj > 0 then
    editRadioButton ('edit', hfig_wk, hobj);
  end
endfunction

function cbEditPopupMenu ()
  disp('Edit opupMenu ...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // seleziona oggetto
  hobj = selectObject (hobjs, 'popupmenu');
  
  // apri finestra con valori attuali
  if hobj > 0 then
    editPopupMenu ('edit', hfig_wk, hobj);
  end
endfunction

function cbEditSlider ()
  disp('Edit Slider ...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // seleziona oggetto
  hobj = selectObject (hobjs, 'slider');
  
  // apri finestra con valori attuali
  if hobj > 0 then
    editSlider ('edit', hfig_wk, hobj);
  end
endfunction


///// EDIT-DELETE //////

function cbDeleteButton()
  disp('Delete Button...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // seleziona oggetto
  hobj = selectObject (hobjs, 'pushbutton');
  
  // elimina oggetto
  if hobj > 0 then
    deleteObject(hobj);
  end
endfunction

function cbDeleteTextField()
  disp('Delete TextField...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // seleziona oggetto
  hobj = selectObject (hobjs, 'edit');
  
  // elimina oggetto
  if hobj > 0 then
    deleteObject(hobj);
  end
endfunction

function cbDeleteLabel()
  disp('Delete Label...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // seleziona oggetto
  hobj = selectObject (hobjs, 'text');
  
  // elimina oggetto
  if hobj > 0 then
    deleteObject(hobj);
  end
endfunction

function cbDeleteListBox()
  disp('Delete ListBox...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // seleziona oggetto
  hobj = selectObject (hobjs, 'listbox');
  
  // elimina oggetto
  if hobj > 0 then
    deleteObject(hobj);
  end
endfunction

function cbDeleteCheckBox()
  disp('Delete CheckBox...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // seleziona oggetto
  hobj = selectObject (hobjs, 'checkbox');
  
  // elimina oggetto
  if hobj > 0 then
    deleteObject(hobj);
  end
endfunction

function cbDeleteFrame ()
  disp('Delete Frame ...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // seleziona oggetto
  hobj = selectObject (hobjs, 'frame');
  
  // elimina oggetto
  if hobj > 0 then
    deleteObject (hobj);
  end
endfunction

function cbDeleteRadioButton ()
  disp('Delete RadioButton ...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // seleziona oggetto
  hobj = selectObject (hobjs, 'radiobutton');
  
  // elimina oggetto
  if hobj > 0 then
    deleteObject (hobj);
  end
endfunction

function cbDeletePopupMenu ()
  disp('Delete PopupMenu ...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // seleziona oggetto
  hobj = selectObject (hobjs, 'popupmenu');
  
  // elimina oggetto
  if hobj > 0 then
    deleteObject (hobj);
  end
endfunction

function cbDeleteSlider ()
  disp('Delete Slider ...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // seleziona oggetto
  hobj = selectObject (hobjs, 'slider');
  
  // elimina oggetto
  if hobj > 0 then
    deleteObject (hobj);
  end
endfunction



///// OPTIONS //////

function cbOptionsGrid()
  disp('Options Grid...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // mostra/rimuovi griglia
  showGrid (hfig_wk);
endfunction



///// HELP //////

function cbHelpAbout()
  disp('Help About...');

  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  x_message(['SciGui v. '+SCIGUI_VERSION, 'G. Casonato - 2007']);
endfunction



///// MISC //////

function resetGlobals ()
  // carica ambiente
  exec('SciGui/SciGui_Env.sci');

  // reset var. globali
//  hfig_wk = 0;
  for i = 1 : size(hobjs, 1)
    // workaround for radiobutton BUG !!
    if get(hobjs(i), 'Style') == 'radiobutton' then
      set(hobjs(i), 'Style', 'checkbox');    
      set(hobjs(i), 'Parent', 1);
    else
      set(hobjs(i), 'Parent', 1);
    end
  end
  hobjs = [];
  hcblist = list();

  hpreinit = list();
  hpostinit = list();
  hauxfun = list();
endfunction

function fname = getFileName (hmode)
  if hmode == 'load'
    fname = tk_getfile ('*.sci', Title='Select SCIGUI file');
  else
    fname = xgetfile ('*.sci', title='Select SCIGUI file');
  end
endfunction

