// *** SciGui push button object handling
// *** by G. Casonato - Marzo 2007

function hobj = loadButton(fd, hfig_wk)
  disp('Load Button...');
  
  // legge dati da file
  str = mgetl(fd, 1); // uicontrol
  str = mgetl(fd, 1); 
  
  // tag
  str = convstr(str, 'l');
  pos = strindex(str, '''tag'', ''');
  str1 = strsplit(str, pos+7);
  str2 = sscanf(str1(2), '%s');
  str3 = strsplit(str2, length(str2)-2);
  objtag = str3(1);    
  str = mgetl(fd, 1); 
  
  // string
  str = convstr(str, 'l');
  pos = strindex(str, '''string'', ''');
  str1 = strsplit(str, pos+10);
  str2 = sscanf(str1(2), '%s');
  str3 = strsplit(str2, length(str2)-2);
  objstr = str3(1);   
  str = mgetl(fd, 1); 
  
  // callback
  str = convstr(str, 'l');
  pos = strindex(str, '''callback'', ''');
  str1 = strsplit(str, pos+12);
  str2 = sscanf(str1(2), '%s');
  str3 = strsplit(str2, length(str2)-2);
  objcb = str3(1);  
  str = mgetl(fd, 1);
  
  // BackgroundColor
  if strindex(str, '''BackgroundColor'', [') == [] then
    bg = name2rgb('gray')/255; // hardcoded BG color
    bg_r = bg(1);
    bg_g = bg(2);
    bg_b = bg(3);
  else
//    pos = strindex(str, '''BackgroundColor'', [');
    pos = strindex(str, '[');
    str1 = strsplit(str, pos);
    [bg_r, bg_g, bg_b] = sscanf(str1(2), '%g %g %g]');
    str = mgetl(fd, 1); 
  end

  // ForegroundColor
  if strindex(str, '''ForegroundColor'', [') == [] then
    fg = name2rgb('black')/255; // hardcoded FG color
    fg_r = fg(1);
    fg_g = fg(2);
    fg_b = fg(3);
  else
//    pos = strindex(str, '''ForegroundColor'', [');
    pos = strindex(str, '[');
    str1 = strsplit(str, pos);
    [fg_r, fg_g, fg_b] = sscanf(str1(2), '%g %g %g]');
    str = mgetl(fd, 1); 
  end

  // position (MUST BE THE LAST)
//  str = mgetl(fd, 1); 
  pos = strindex(str, '[');
  str1 = strsplit(str, pos);
  [px, py, wd, hg] = sscanf(str1(2), '%d %d %d %d]');

  // crea oggetto
  hobj = uicontrol(hfig_wk, 'Style', 'pushbutton', ...
    'Tag', objtag, ...
    'String', objstr, ...
    'Callback', objcb, ...
    'BackgroundColor', [bg_r, bg_g, bg_b], ...
    'ForegroundColor', [fg_r, fg_g, fg_b], ...
    'Position', [px py wd hg]);
endfunction

function saveButton (fd, hobj)
  disp('Save Button...');

  tag = get(hobj, 'Tag');
  pos = get(hobj, 'Position');
  pos = evstr(pos);
  str = get(hobj, 'String');
  cb = get(hobj, 'Callback');
  bg = get(hobj, 'BackgroundColor');
  bg = evstr(bg);
  fg = get(hobj, 'ForegroundColor');
  fg = evstr(fg);
  mfprintf(fd, '// BUTTON: %s\n', tag);
  mfprintf(fd, 'hobj = uicontrol(hfig, ''Style'', ''pushbutton'', ...\n');
  mfprintf(fd, '  ''Tag'', ''%s'', ...\n', tag);
  mfprintf(fd, '  ''String'', ''%s'', ...\n', str);
  mfprintf(fd, '  ''Callback'', ''%s'', ...\n', cb);
  mfprintf(fd, '  ''BackgroundColor'', [%g %g %g], ...\n', bg(1), bg(2), bg(3));
  mfprintf(fd, '  ''ForegroundColor'', [%g %g %g], ...\n', fg(1), fg(2), fg(3));
  mfprintf(fd, '  ''Position'', [%d %d %d %d]);\n\n', pos(1), pos(2), pos(3), pos(4)); 
endfunction

function hobj = editButton (hmode, hfig_wk, hobj)
  disp('Edit Button...');
  
  // hmode definisce modalit:
  // - new:  crea nuova oggetto con ID <hobj>
  // - edit: modifica oggetto esistente <hobj>

  // legge posizione/nome
  if hmode == 'edit' then
    // edit: legge valori correnti
    objpos = get(hobj, 'Position');
    objstr = get(hobj, 'String');
    objbg = get(hobj, 'BackgroundColor');
    objbg = evstr(objbg);
    objfg = get(hobj, 'ForegroundColor');
    objfg = evstr(objfg);
  else
    // new: imposta valori di default
    objpos = [100 100 50 20];
    objtag = 'Button'+string(hobj);
    objstr = objtag;
    objcb = 'cbButton'+string(hobj);
    objbg = name2rgb('gray')/255;
    objfg = name2rgb('black')/255;
  end  
  
  objbg = rgb2name(objbg*255);
  objfg = rgb2name(objfg*255);

  // legge posizione/valore
  lbl = ['Position (x, y): '; ...
         'Size (width, height): '; ...
         'BG color name: '; ...
         'FG color name: '; ...
         'Label: '];
  def = [string(objpos(1))+' '+string(objpos(2)); ...
         string(objpos(3))+' '+string(objpos(4)); ...
         objbg(1); ...
         objfg(1); ...
         objstr];
  objdata = x_mdialog('enter object data', lbl, def);
  objpos = evstr(objdata(1 : 2));
  objbg = name2rgb(objdata(3))/255;
  objfg = name2rgb(objdata(4))/255;
  objstr = objdata(5);

  px = objpos(1,1);
  py = objpos(1,2);
  wd = objpos(2,1);
  hg = objpos(2,2);

  bg_r = objbg(1);
  bg_g = objbg(2);
  bg_b = objbg(3);

  fg_r = objfg(1);
  fg_g = objfg(2);
  fg_b = objfg(3);

  // applica parametri
  if hmode == 'edit' then
    // edit: modifica parametri oggetto   
    set(hobj, 'Position', [px py wd hg]);
    set(hobj, 'String', objstr);
    set(hobj, 'BackgroundColor', [bg_r, bg_g, bg_b]);
    set(hobj, 'ForegroundColor', [fg_r, fg_g, fg_b]);
  else
    // new: aggiunge oggetto nella posizione specificata
    hobj = uicontrol(hfig_wk, 'Style', 'pushbutton', ...
      'Tag', objtag, ...
      'String', string(objstr), ...
      'Callback', objcb, ...
      'BackgroundColor', [bg_r, bg_g, bg_b], ...
      'ForegroundColor', [fg_r, fg_g, fg_b], ...
      'Position', [px py wd hg]);
  end  
endfunction


