// *** SciGui generic object handling
// *** by G. Casonato - Marzo 2007

function hobj = selectObject(hobjs, objstyle)
  // costruisce matrice oggetti dello 'style' fornito

  objmat = [];
  for i = 1 : size(hobjs, 1)
    if (get(hobjs(i), 'Style') == objstyle) & ...
       (get(hobjs(i), 'Parent') > 1) then
      str = get(hobjs(i), 'Tag');
      objmat = [objmat; [str string(hobjs(i))]];
    end
  end
  
  // richiede scelta
  if size(objmat, 1) > 0 then
    sel = x_choose(objmat(:, 1), ['Select object']);
    if sel > 0 then
      hobj = evstr(objmat(sel, 2));
    else
      hobj = 0;
    end
  end
endfunction


function deleteObject(hobj)
  res = x_message(['Do you confirm deletion?'], ['Yes','No']);
  if res == 1 then
    set(hobj, 'Parent', 1);
  end
endfunction


function props = getProps (hobj, prNames)
  props = list();

  for i = 1 : length(prNames)
    try
      prop = prNames(i);
      val = get(hobj, prop);
      prls = list(prop, val);
      props($+1) = prls;
    catch
    // discard
    end
  end
endfunction

function props = getAllObjProps (hobj)
  prNames = list();
  prNames($+1) = 'Style';
  prNames($+1) = 'Position';
  prNames($+1) = 'Tag';
  prNames($+1) = 'String';
  prNames($+1) = 'HorizontalAlignment';
  prNames($+1) = 'VerticalAlignment';
  prNames($+1) = 'Callback';
  prNames($+1) = 'FontAngle';
  prNames($+1) = 'FontSize';
  prNames($+1) = 'FontUnits';
  prNames($+1) = 'FontWeight';
  prNames($+1) = 'FontName';
  prNames($+1) = 'ForegroundColor';
  prNames($+1) = 'BackgroundColor';
  prNames($+1) = 'ListboxTop';
  prNames($+1) = 'Max';
  prNames($+1) = 'Min';
  prNames($+1) = 'Parent';
  prNames($+1) = 'Path';
  prNames($+1) = 'SliderStep';
  prNames($+1) = 'Units';
  prNames($+1) = 'Userdata';
  prNames($+1) = 'Value';

  props = getProps(hobj, prNames);

  printf('*** object <%d> properties ***\n', hobj);
  for i = 1 : length(props)
    printf('  %s --> %s\n', props(i)(1), sci2exp(props(i)(2)));
  end
  printf('**************************\n\n');
  
endfunction



//function hprop = loadObject(fd, hfig_wk)
//  disp('Load Object...');
//  
//  // crea struttura
//  hprop = emptyPropStruct();
//  
//  // legge dati da file
//  while (eof(fd) == %F)
//    // legge linea
//    str = mgetl(fd, 1); 
//    
//    // processa propriet
//    if strindex(str, '''Tag'', ''') > 0 then
//      pos = strindex(str, '''Tag'', ''');
//      str1 = strsplit(str, pos+7);
//      str2 = sscanf(str1(2), '%s');
//      str3 = strsplit(str2, length(str2)-2);
//      hprop.Tag = str3(1);
//
//    elseif strindex(str, '''String'', ''') > 0 then
//      pos = strindex(str, '''String'', ''');
//      str1 = strsplit(str, pos+10);
//      str2 = sscanf(str1(2), '%s');
//      str3 = strsplit(str2, length(str2)-2);
//      hprop.String = str3(1);
//
//    elseif strindex(str, '''HorizontalAlignment'', ''') > 0 then
//      pos = strindex(str, '''HorizontalAlignment'', ''');
//      str1 = strsplit(str, pos+23);
//      str2 = sscanf(str1(2), '%s');
//      str3 = strsplit(str2, length(str2)-2);
//      hprop.HorizontalAlignment = str3(1);
//
////...altre...
//    end
//    
//  end
//
//endfunction
//
//function saveObject (fd, hobj)
//  disp('Save Object...');
//
//...
//
//endfunction
//
//function prSt = emptyPropStruct ()
//  // struttura propriet vuota
//  prSt = struct('Style', '', ...
//                'Tag', '', ...
//                'Position', [], ...
//                'String', '', ...
//                'HorizontalAlignment', '', ...
//                'VerticalAlignment', '', ...
//                'Callback', '', ...
//                'FontAngle', '', ...
//                'FontSize', [], ...
//                'FontUnits', '', ...
//                'FontWeight', '', ...
//                'FontName', '', ...
//                'ForegroundColor', '', ...
//                'BackgroundColor', '', ...
//                'ListboxTop', [], ...
//                'Max', [], ...
//                'Min', [], ...
//                'Parent', [], ...
//                'Path', '', ...
//                'SliderStep', [], ...
//                'Units', '', ...
//                'Userdata', '', ...
//                'Value', '', ...
//                ); 
//endfunction

