// *** SciGui popupmenu object handling
// *** by G. Casonato - Aprile 2007

function hobj = loadPopupMenu (fd, hfig_wk)
  disp('Load PopupMenu ...');
  
  // legge dati da file
  str = mgetl(fd, 1); // uicontrol
  
  // tag
  str = mgetl(fd, 1); 
  pos = strindex(str, '''Tag'', ''');
  str1 = strsplit(str, pos+7);
  str2 = sscanf(str1(2), '%s');
  str3 = strsplit(str2, length(str2)-2);
  objtag = str3(1);
  str = mgetl(fd, 1);
  
  // string
  pos = strindex(str, '''String'', ''');
  str1 = strsplit(str, pos+10);
  str2 = sscanf(str1(2), '%s');
  str3 = strsplit(str2, length(str2)-2);
  objstr = str3(1);
  str = mgetl(fd, 1); 
  
  // position
  pos = strindex(str, '[');
  str1 = strsplit(str, pos);
  [px, py, wd, hg] = sscanf(str1(2), '%d %d %d %d]');

  // crea oggetto
  hobj = uicontrol(hfig_wk, 'Style', 'popupmenu', ...
    'Tag', objtag, ...
    'String', objstr, ...
    'Position', [px py wd hg]);

////// fill the list
////set(hlbox, 'string', "item 1|item 2|item3");
////set(hlbox, 'value', [1 3]);
endfunction

function savePopupMenu (fd, hobj)
  disp('Save PopupMenu ...');

  tag = get(hobj, 'Tag');
  pos = get(hobj, 'Position');
  pos = evstr(pos);
  str = get(hobj, 'String');
  mfprintf(fd, '// POPUPMENU: %s\n', tag);
  mfprintf(fd, 'hobj = uicontrol(hfig, ''Style'', ''popupmenu'', ...\n');
  mfprintf(fd, '  ''Tag'', ''%s'', ...\n', tag);
  mfprintf(fd, '  ''String'', ''%s'', ...\n', str);
  mfprintf(fd, '  ''Position'', [%d %d %d %d]);\n\n', pos(1), pos(2), pos(3), pos(4)); 
endfunction

function hobj = editPopupMenu (hmode, hfig_wk, hobj)
  disp('Edit PopupMenu ...');

  // hmode definisce modalit:
  // - new:  crea nuova oggetto con ID <hobj>
  // - edit: modifica oggetto esistente <hobj>

  // legge posizione/nome
  if hmode == 'edit' then
    // edit: legge valori correnti
    objpos = get(hobj, 'Position');
    objstr = get(hobj, 'String');
  else
    // new: imposta valori di default
    objpos = [100 50 100 20];
    objtag = 'PopupMenu'+string(hobj);
    objstr = objtag;
  end  
  
  // legge posizione
  lbl = ['Position (x, y): ';
         'Size (width, height): '];
  def = [string(objpos(1))+' '+string(objpos(2)); ...
         string(objpos(3))+' '+string(objpos(4))];
  objdata = x_mdialog('enter object data', lbl, def);
  objpos = evstr(objdata(1 : 2));

  px = objpos(1,1);
  py = objpos(1,2);
  wd = objpos(2,1);
  hg = objpos(2,2);

  if hmode == 'edit' then
    // edit: modifica parametri oggetto   
    set(hobj, 'Position', [px py wd hg]);
  else
    // new: aggiunge oggetto nella posizione specificata
    hobj = uicontrol(hfig_wk, 'Style', 'popupmenu', ...
      'Tag', objtag, ...
      'String', objstr, ...
      'Position', [px py wd hg]);
  end
endfunction


